#!/usr/bin/env python 
import sys 
import Raisetest, Raisetest__POA 

#-----------------------------------------------------------------------
#-- Define an implementation of the Raisetest.Test interface .
#-----------------------------------------------------------------------
class Raisetest_i (Raisetest__POA.Test):
    def __init__(self, name):
        self._name = name
        
    #--------------------------------
    #-- Return list of Element1
    #--------------------------------
    def testMethod1(self):
        '''
        Same element list as in testRaise2 (which causes an error when defined in between an exception) as return value of the method.
        '''
        eleList = []
        resState = Raisetest.ResultState_m.Success
        for i in xrange(10):
            teststr = "url"
            text = Raisetest.Text("key{0}".format(i), "par{0}".format(i).ljust(872,'X'))
            ei = Raisetest.Element1(resState, teststr, text)
            eleList.append(ei)
            
        return eleList
    
    #--------------------------------
    #-- Raise exceptions for Element1
    #--------------------------------
    def testRaise1(self):
        '''
        OK.
        '''
        eleList = []
        resState = Raisetest.ResultState_m.Success
        for i in xrange(10):
            teststr = "url"
            text = Raisetest.Text("key{0}".format(i), "par{0}".format(i).ljust(871,'X'))
            ei = Raisetest.Element1(resState, teststr, text)
            eleList.append(ei)
        ex = Raisetest.Extest1(eleList)
        raise ex

    def testRaise2(self):
        '''
        Failed because of a fixed value attribute 'teststr' in combination with a certain length for attribute 'message'.
        
        This causes following error:
            omniORB: From endpoint: giop:tcp:172.20.136.43:6022. Detected GIOP 1.2 protocol error in input message. giopImpl12.cc:885. Connection is closed.
            General exception catched: CORBA.COMM_FAILURE(omniORB.COMM_FAILURE_UnMarshalResults, CORBA.COMPLETED_YES)        
        '''
        eleList = []
        resState = Raisetest.ResultState_m.Success
        for i in xrange(10):
            teststr = "url"
            text = Raisetest.Text("key{0}".format(i), "par{0}".format(i).ljust(872,'X'))
            ei = Raisetest.Element1(resState, teststr, text)
            eleList.append(ei)
        ex = Raisetest.Extest1(eleList)
        raise ex

    def testRaise3(self):
        '''
        Same length for attribute 'message' (see testRaise2) but different values for attribute 'teststr'.
        
        OK.
        '''
        eleList = []
        resState = Raisetest.ResultState_m.Success
        for i in xrange(10):
            teststr = "url{0}".format(i)
            text = Raisetest.Text("key{0}".format(i), "par{0}".format(i).ljust(872,'X'))
            ei = Raisetest.Element1(resState, teststr, text)
            eleList.append(ei)
        ex = Raisetest.Extest1(eleList)
        raise ex
        
    #-----------------------------------------------------------------------------------------------
    #-- Methods for Element2
    #-- Exactly same methods as for Element1. The only difference is the attribute 'teststr':
    #--    For Element1 this is: valuetype Testval
    #--    For Element2 this is: string
    #-----------------------------------------------------------------------------------------------
    def testRaise4(self):
        '''
        OK.
        '''
        eleList = []
        resState = Raisetest.ResultState_m.Success
        for i in xrange(10):
            teststr = "url"
            text = Raisetest.Text("key{0}".format(i), "par{0}".format(i).ljust(871,'X'))
            ei = Raisetest.Element2(resState, teststr, text)
            eleList.append(ei)
        ex = Raisetest.Extest2(eleList)
        raise ex

    def testRaise5(self):
        '''
        OK.
        '''
        eleList = []
        resState = Raisetest.ResultState_m.Success
        for i in xrange(10):
            teststr = "url"
            text = Raisetest.Text("key{0}".format(i), "par{0}".format(i).ljust(872,'X'))
            ei = Raisetest.Element2(resState, teststr, text)
            eleList.append(ei)
        ex = Raisetest.Extest2(eleList)
        raise ex
        
    def testRaise6(self):
        '''
        OK.
        '''
        eleList = []
        resState = Raisetest.ResultState_m.Success
        for i in xrange(10):
            teststr = "url{0}".format(i)
            text = Raisetest.Text("key{0}".format(i), "par{0}".format(i).ljust(872,'X'))
            ei = Raisetest.Element2(resState, teststr, text)
            eleList.append(ei)
        ex = Raisetest.Extest2(eleList)
        raise ex
        